<?php
$iface[0]="eth0"; 
$iface[1]="eth1";
//$iface[2]="eth2";
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title>Teste Grafico</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta http-equiv="Pragma" content="no-cache">
<!--[if IE]><script type="text/javascript" src="flotr/lib/excanvas.js"></script><![endif]-->
<script type="text/javascript" src="flotr/lib/prototype-1.6.0.2.js"></script>
<script type="text/javascript" src="flotr/flotr.js"></script>
<style>
td,th{
font-family: Verdana, Arial, Helvetica, sans-serif;
font-size: 11px;
}
</style>
<script type="text/javascript" language="javascript">
//<!--
var ready = true;
var data_timer = 0;
var max_data = 30;
<?php
$arg=implode(",",$iface); 
for($i=0;$i<count($iface);$i++){
	echo "var ".$iface[$i]."_data = new PlotData(2, max_data);\n";
	echo "var last_uptime_".$iface[$i]." = 0;\n"; 
}	
?>
var dev_uptime = 0;
var old_uptime = 0;
var series_count = 2;

function reloadFrame(frameName) {
	var frame, iframe;
	frame = window.frames[frameName];
	iframe = document.getElementById(frameName);
	if (frame && iframe) {
		last_uptime = dev_uptime;
		frame.location.reload();
	}
} 

function desenha_grafico(div_id,rxbytes,txbytes){
	if (ready) {
		if (data_timer) 
                	clearTimeout(data_timer);
		data_timer = setTimeout("reloadFrame('statusFrame')", 1000);
	}
        else {
		if (data_timer) 
                	clearTimeout(data_timer);
		data_timer = setTimeout("reloadFrame('statusFrame')", 500);
	}
	
	var curdate = new Date()
	dev_uptime = curdate.getTime();
	<?php 
		for($i=0;$i<count($iface);$i++){
			echo "if(div_id == '".$iface[$i]."'){\n";
					
			echo "	update_d".$iface[$i]."(div_id,rxbytes,txbytes,dev_uptime,last_uptime_".$iface[$i].");\n";
			echo "last_uptime_".$iface[$i]." = dev_uptime;\n";
			echo "}\n";
		}
	?>
	

	//alert("rxbt: "+rxbt+"\n"+"txbt: "+txbt+"\n"+"dev_uptime: "+dev_uptime+"\n"+"last_uptime: "+last_uptime+"\n"+"old_uptime: "+old_uptime+"\n");
}
function update_misc() {
	if (isNaN(uptime))
		dev_uptime = (dev_uptime == 0 ? (new Date()).getTime() / 1000 : dev_uptime + 5); //for testing
	else dev_uptime = uptime;
}

function normalize_max(val, ticks)
{
	var delta = val / ticks;
	var magn = Math.pow(10, Math.floor(Math.log(delta) / Math.LN10));
	var norm = delta / magn;
	var tick_size = 10;
	if(norm < 1.5) tick_size = 1;
	else if(norm < 2.25) tick_size = 2;
	else if(norm < 3) tick_size = 2.5;
	else if(norm < 7.5) tick_size = 5;
	tick_size *= magn;
	if (Math.floor(val / tick_size) * tick_size >= val)
	{
		return val;
	}
	return (Math.floor(val / tick_size) + 1) * tick_size;
}

function normalize_float(value)
{
	if (Math.round(value * 100) < 1000)
	{
		value = Math.round(value * 100) / 100;
	}
	else if (Math.round(value * 10) < 1000)
	{
		value = Math.round(value * 10) / 10;
	}
	else
	{
		value = Math.round(value);
	}
	return value;
}

function formatBPS(value)
{
	var unit;
	var power;
	if (Math.round(value) < 1024)
	{
		unit = "Kbps";
		power = 0;
	}
	else if (Math.round(value / 1024) < 1024)
	{
		value = value / 1024;
		unit = "Mbps";
		power = 1;
	}
	else
	{
		value = value / 1024 / 1024;
		unit = "Gbps";
		power = 2;		
	}
	value = normalize_float(value)
	return [value, unit, power, ""+value+unit];
}

function updateCanvas(id, data)
{
	if (!ready)
	{
		return;
	}
	var dp = data.get_plot_values();
	rx = formatBPS(dp[3][0])[3];
	tx = formatBPS(dp[3][1])[3];
	var f = Flotr.draw($(id),
		[ 
			{data:dp[0][0], label:'Download: '+rx, lines: {show: true, lineWidth: 3}, points: {show: true, lineWidth: 1, radius: 2}}, 
			{data:dp[0][1], label:'Upload: '+tx, lines: {show: true, lineWidth: 3}, points: {show: true, lineWidth: 1, radius: 2}} 
		],
		{
			xaxis:{
				noTicks: data.max_data,
				tickFormatter: function(n){ return ''; },
				min: 0,
				max: data.max_data
			},
			yaxis:{
				noTicks: 8,
				tickFormatter: function(n){	return n == 0 ? dp[1]+' 0' : n; },
				min: 0,
				max: dp[2]
			},
			legend: {
				position: 'nw',
				backgroundOpacity: 0.2
			}
		});
}
<?php 
for($i=0;$i<count($iface);$i++){
	echo "function update_d".$iface[$i]."(div_id,rxbytes,txbytes,dev_uptime,last_uptime) {\n";
	echo "	update_all('".$iface[$i]."', ".$iface[$i]."_data, rxbytes, txbytes,dev_uptime,last_uptime);\n";
	echo "}\n";
}
?>
function PlotData(series_count, max_data) 
{
	
	this.max_data = max_data;
	this.last = new Array(series_count);
	this.data = new Array(series_count);
	
	for (var i=0; i < series_count; ++i)
	{
		this.last[i] = 0;
		this.data[i] = new Array();		
	}

	this.add_values = function (values, sec)
	{
		var last;
		if (sec <= 0)
		{
			return;
		}
		for (var i = 0; i < this.data.length; ++i)
		{			
			if (this.data[i].length >= this.max_data)
			{
				this.data[i].shift();
			}
			if (values[i])
			{
				last = parseFloat(values[i]);
				this.data[i].push((last - this.last[i]) / sec * 8); // bps
				// TODO: handle overwrap ?
				this.last[i] = last;
			}
			else
			{
				this.data[i].push(0);
			}		
		}		
	}

	this.get_plot_values = function()
	{
		var result = new Array();
		var tmp;
		var max = 100; // 100 bps
		var format;
		var last = new Array();
		for (var i = 0; i < this.data.length; ++i)
		{
			result[i] = new Array();
			for (var j = 0; j < this.data[i].length; ++j)
			{
				tmp = this.data[i][j];
				if (tmp > max)
				{
					max = tmp;
				}
				result[i][j] = [j, tmp]
			}
			last[i] = this.data[i][j-1];
		}
		format = formatBPS(max);
		max = normalize_max(format[0], 8);
		if (format[2] > 0)
		{
			for (var i = 0; i < result.length; ++i)
			{
				for (var j = 0; j < result[i].length; ++j)
				{
					 result[i][j][1] /= Math.pow(1024, format[2]);
				}
			}
		}
		//alert("result: "+result+"\n"+"format: "+format[1]+"\n"+"max: "+max+"\n"+"last: "+last+"\n");
		return [result, format[1], max, last]; // data, unit, normalized value
	}
}

function update_all(id, data, rxbytes, txbytes, dev_uptime, last_uptime) {
	data.add_values( [rxbytes, txbytes], dev_uptime - last_uptime);
	updateCanvas(id, data);
}

document.observe('dom:loaded', function(){
	ready = true;
});

	//-->
</script>
</head>
<body>
<form action="#" method="GET">
<table cellspacing="8" cellpadding="0" align="center" id="throughput" style="width:470;">
<?php 
for($i=0;$i<count($iface);$i++){
?>
	<tr><th colspan="6"><?=$iface[$i]?></th></tr>
	<tr>
	  <td colspan="6">
	  	<div style="border: 1px solid #ffffff;">
		<div id="<?=$iface[$i]?>" style="position:relative;height:150px;width:468px;"></div>
		</div>
	  </td>
	</tr>
<?php 
}
?>
	<tr>
	  <td colspan="4">&nbsp;</td>
          <td align="right"><input type="button" onClick="return reloadFrame('statusFrame');" value="Refresh"></input></td>
	  <td>&nbsp;</td>
	</tr>
</table>
<iframe name="statusFrame" id="statusFrame"
        marginwidth="0" marginheight="0" height="0" width="0" frameborder="0"
        scrolling="no" src="status.php?arg=<?=urlencode($arg)?>">
</iframe>
</form>
</body>
</html>
