<?php 
$serie_nome[0]="HTTP/HTTPS - Down";
$serie_nome[1]="HTTP/HTTPS - UP";
$serie_nome[2]="SMTP";
$serie_nome[3]="POP/IMAP";
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title>Teste Grafico</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta http-equiv="Pragma" content="no-cache">
<!--[if IE]><script type="text/javascript" src="flotr/lib/excanvas.js"></script><![endif]-->
<script type="text/javascript" src="flotr/lib/prototype-1.6.0.2.js"></script>
<script type="text/javascript" src="flotr/flotr.js"></script>
<style>
td,th{
font-family: Verdana, Arial, Helvetica, sans-serif;
font-size: 11px;
}
</style>
<script type="text/javascript" language="javascript">
//<!--
var ready = true;
var data_timer = 0;
var max_data = 10;
<?echo "var infodata = new PlotData(".count($serie_nome).", max_data);"; ?>
var last_uptime = 0;
var dev_uptime = 0;
var old_uptime = 0;
var series_count = 3;

function explode (delimiter, string, limit) {
    // Splits a string on string separator and return array of components. If limit is positive only limit number of components is returned. If limit is negative all components except the last abs(limit) are returned.  
    // 
    // version: 1109.2015
    // discuss at: http://phpjs.org/functions/explode    // +     original by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
    // +     improved by: kenneth
    // +     improved by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
    // +     improved by: d3x
    // +     bugfixed by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)    // *     example 1: explode(' ', 'Kevin van Zonneveld');
    // *     returns 1: {0: 'Kevin', 1: 'van', 2: 'Zonneveld'}
    // *     example 2: explode('=', 'a=bc=d', 2);
    // *     returns 2: ['a', 'bc=d']
    var emptyArray = {        0: ''
    };
 
    // third argument is not required
    if (arguments.length < 2 || typeof arguments[0] == 'undefined' || typeof arguments[1] == 'undefined') {        return null;
    }
 
    if (delimiter === '' || delimiter === false || delimiter === null) {
        return false;    }
 
    if (typeof delimiter == 'function' || typeof delimiter == 'object' || typeof string == 'function' || typeof string == 'object') {
        return emptyArray;
    } 
    if (delimiter === true) {
        delimiter = '1';
    }
     if (!limit) {
        return string.toString().split(delimiter.toString());
    }
    // support for limit argument
    var splitted = string.toString().split(delimiter.toString());    var partA = splitted.splice(0, limit - 1);
    var partB = splitted.join(delimiter.toString());
    partA.push(partB);
    return partA;
}

function reloadFrame(frameName) {
	var frame, iframe;
	frame = window.frames[frameName];
	iframe = document.getElementById(frameName);
	if (frame && iframe) {
		last_uptime = dev_uptime;
		frame.location.reload();
	}
} 

function desenha_grafico(bytes){
	if (ready) {
		if (data_timer) 
                	clearTimeout(data_timer);
		data_timer = setTimeout("reloadFrame('statusFrame')", 1000);
	}
        else {
		if (data_timer) 
                	clearTimeout(data_timer);
		data_timer = setTimeout("reloadFrame('statusFrame')", 500);
	}
	var curdate = new Date()
	dev_uptime = curdate.getTime();
	update_chart(bytes,dev_uptime,last_uptime);
	last_uptime = dev_uptime;
	//alert("rxbt: "+rxbt+"\n"+"txbt: "+txbt+"\n"+"dev_uptime: "+dev_uptime+"\n"+"last_uptime: "+last_uptime+"\n"+"old_uptime: "+old_uptime+"\n");
}
function update_misc() {
	if (isNaN(uptime))
		dev_uptime = (dev_uptime == 0 ? (new Date()).getTime() / 1000 : dev_uptime + 5); //for testing
	else dev_uptime = uptime;
}

function normalize_max(val, ticks)
{
	var delta = val / ticks;
	var magn = Math.pow(10, Math.floor(Math.log(delta) / Math.LN10));
	var norm = delta / magn;
	var tick_size = 10;
	if(norm < 1.5) tick_size = 1;
	else if(norm < 2.25) tick_size = 2;
	else if(norm < 3) tick_size = 2.5;
	else if(norm < 7.5) tick_size = 5;
	tick_size *= magn;
	if (Math.floor(val / tick_size) * tick_size >= val)
	{
		return val;
	}
	return (Math.floor(val / tick_size) + 1) * tick_size;
}

function normalize_float(value)
{
	if (Math.round(value * 100) < 1000)
	{
		value = Math.round(value * 100) / 100;
	}
	else if (Math.round(value * 10) < 1000)
	{
		value = Math.round(value * 10) / 10;
	}
	else
	{
		value = Math.round(value);
	}
	return value;
}

function formatBPS(value)
{
	var unit;
	var power;
	if (Math.round(value) < 1024)
	{
		unit = "Kbps";
		power = 0;
	}
	else if (Math.round(value / 1024) < 1024)
	{
		value = value / 1024;
		unit = "Mbps";
		power = 1;
	}
	else
	{
		value = value / 1024 / 1024;
		unit = "Gbps";
		power = 2;		
	}
	value = normalize_float(value)
	return [value, unit, power, ""+value+unit];
}

function updateCanvas(id, data)
{
	if (!ready)
	{
		return;
	}
	var dp = data.get_plot_values();
	

<?php
 for($i=0;$i<count($serie_nome);$i++){
	echo "byte_".$i." = formatBPS(dp[3][".$i."])[3];\n";
}
?>
	//alert("dp: "+byte_1);
	var f = Flotr.draw($(id),
		[
<?php
		 for($i=0;$i<count($serie_nome);$i++){ 
			echo "{data:dp[0][".$i."], label:'".$serie_nome[$i].": '+byte_".$i.", lines: {show: true, lineWidth: 3}, points: {show: true, lineWidth: 1, radius: 2}}";
			if ($i<count($serie_nome)-1){
				echo ",\n";
			}else{
				echo "\n";	
			}
		 }
?>  
		],
		{
			xaxis:{
				noTicks: data.max_data,
				tickFormatter: function(n){ return ''; },
				min: 0,
				max: data.max_data
			},
			yaxis:{
				noTicks: 8,
				tickFormatter: function(n){	return n == 0 ? dp[1]+' 0' : n; },
				min: 0,
				max: dp[2]
			},
			legend: {
				position: 'nw',
				backgroundOpacity: 0.2
			}
		});
}

function update_chart(bytes,dev_uptime,last_uptime) {
	//(infodata+"\n"+bytes+"\n"+dev_uptime+"\n"+last_uptime);
	update_all('infograph', infodata, bytes, dev_uptime, last_uptime);
}
function PlotData(series_count, max_data) 
{
	
	this.max_data = max_data;
	this.last = new Array(series_count);
	this.data = new Array(series_count);
	
	for (var i=0; i < series_count; ++i)
	{
		this.last[i] = 0;
		this.data[i] = new Array();		
	}

	this.add_values = function (values, sec)
	{
		
		var last;
		if (sec <= 0)
		{
			return;
		}
		for (var i = 0; i < this.data.length; ++i)
		{	
			//alert("Contagem: "+i+"\n"+values[i]);		
			if (this.data[i].length >= this.max_data)
			{
				this.data[i].shift();
			}
			if (values[i])
			{
				last = parseFloat(values[i]);
				this.data[i].push((last - this.last[i]) / sec * 8); // bps
				// TODO: handle overwrap ?
				this.last[i] = last;
			}
			else
			{
				this.data[i].push(0);
			}		
		}
	}

	this.get_plot_values = function()
	{
		var result = new Array();
		var tmp;
		var max = 1; // 100 bps
		var format;
		var last = new Array();
		for (var i = 0; i < this.data.length; ++i)
		{
			result[i] = new Array();
			for (var j = 0; j < this.data[i].length; ++j)
			{
				tmp = this.data[i][j];
				
				if (tmp > max)
				{
					max = tmp;
				}
				result[i][j] = [j, tmp]
			}
			last[i] = this.data[i][j-1];
		}
		format = formatBPS(max);
		max = normalize_max(format[0], 8);
		if (format[2] > 0)
		{
			for (var i = 0; i < result.length; ++i)
			{
				for (var j = 0; j < result[i].length; ++j)
				{
					 result[i][j][1] /= Math.pow(1024, format[2]);
				}
			}
		}
		//alert("result: "+result+"\n"+"format: "+format[1]+"\n"+"max: "+max+"\n"+"last: "+last+"\n");
		return [result, format[1], max, last]; // data, unit, normalized value
	}
}

function update_all(id, data, bytes, dev_uptime, last_uptime) {
	data.add_values(bytes, dev_uptime - last_uptime);			
	updateCanvas(id, data);
}

document.observe('dom:loaded', function(){
	ready = true;
});

	//-->
</script>
</head>
<body>
<form action="#" method="GET">
<table cellspacing="8" cellpadding="0" align="center" id="throughput" style="width:470;">
	<tr><th colspan="6">Relatório</th></tr>
	<tr>
	  <td colspan="6">
	  	<div style="border: 1px solid #ffffff;">
		<div id="infograph" style="position:relative;height:150px;width:468px;"></div>
		</div>
	  </td>
	</tr>
	<tr>
	  <td colspan="4">&nbsp;</td>
          <td align="right"><input type="button" onClick="return reloadFrame('statusFrame');" value="Refresh"></input></td>
	  <td>&nbsp;</td>
	</tr>
</table>
<iframe name="statusFrame" id="statusFrame"
        marginwidth="0" marginheight="0" height="0" width="0" frameborder="0"
        scrolling="no" src="status2.php">
</iframe>
</form>
</body>
</html>
